/*
 * @(#)StringConverter.java	1.00 10/16/2002
 *
 * Copyright 2002 Kosuke Yamamoto, All rights reserved.
 * http://www.bystonwell.com/
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package com.bystonwell.util;

/**
 * ϊsNXłB
 * -J^Ji̕ϊAсApLJȋSp-p̕ϊ삪\łB
 *
 * @author  Kosuke Yamamoto
 * @version 1.00, 10/16/2002
 * @since   JDK1.2
 */
public class StringConverter {

	/** ftHgRXgN^ */
	private StringConverter() {
	}

	/** pJ^Jie[u */
	protected static final String NORMAL_WIDTH_KATAKANA_TABLE =
			"\uff61\uff62\uff63\uff64\uff65"	// 
			+ "\uff67\uff68\uff69\uff6a\uff6b"	// 
			+ "\uff6c\uff6d\uff6e\uff6f\uff70"	// 
			+ "\uff71\uff72\uff73\uff74\uff75"	// 
			+ "\uff76\uff77\uff78\uff79\uff7a"	// 
			+ "\uff7b\uff7c\uff7d\uff7e\uff7f"	// 
			+ "\uff80\uff81\uff82\uff83\uff84"	// 
			+ "\uff85\uff86\uff87\uff88\uff89"	// 
			+ "\uff8a\uff8b\uff8c\uff8d\uff8e"	// 
			+ "\uff8f\uff90\uff91\uff92\uff93"	// 
			+ "\uff94\uff95\uff96"				// 
			+ "\uff97\uff98\uff99\uff9a\uff9b"	// 
			+ "\uff9c\uff66\uff9d\uff9e\uff9f";	// ܦ

	/** pJ^Jie[u(ɂȂ肤锼pJ^Jĩe[u) */
	protected static final String NORMAL_WIDTH_DAKUON_KATAKANA_TABLE =
			"\uff76\uff77\uff78\uff79\uff7a"	// (޷޸޹޺)
			+ "\uff7b\uff7c\uff7d\uff7e\uff7f"	// (޼޽޾޿)
			+ "\uff80\uff81\uff82\uff83\uff84"	// ()
			+ "\uff8a\uff8b\uff8c\uff8d\uff8e"	// ()
			+ "\uff73";							// ()

	/** pJ^Jie[u(ɂȂ肤锼pJ^Jĩe[u) */
	protected static final String NORMAL_WIDTH_HANDAKUON_KATAKANA_TABLE =
			"\uff8a\uff8b\uff8c\uff8d\uff8e";	// ()

	/** SpJ^Jie[u */
	protected static final String EM_SIZE_KATAKANA_TABLE =
			"\u3002\u300c\u300d\u3001\u30fb"	// BuvAE
			+ "\u30a1\u30a3\u30a5\u30a7\u30a9"	// @BDFH
			+ "\u30e3\u30e5\u30e7\u30c3\u30fc"	// b[
			+ "\u30a2\u30a4\u30a6\u30a8\u30aa"	// ACEGI
			+ "\u30ab\u30ad\u30af\u30b1\u30b3"	// JLNPR
			+ "\u30b5\u30b7\u30b9\u30bb\u30bd"	// TVXZ\
			+ "\u30bf\u30c1\u30c4\u30c6\u30c8"	// ^`ceg
			+ "\u30ca\u30cb\u30cc\u30cd\u30ce"	// ijklm
			+ "\u30cf\u30d2\u30d5\u30d8\u30db"	// nqtwz
			+ "\u30de\u30df\u30e0\u30e1\u30e2"	// }~
			+ "\u30e4\u30e6\u30e8"				// 
			+ "\u30e9\u30ea\u30eb\u30ec\u30ed"	// 
			+ "\u30ef\u30f2\u30f3\u309b\u309c";	// JK

	/** SpJ^Jie[u */
	protected static final String EM_SIZE_DAKUON_KATAKANA_TABLE =
			"\u30ac\u30ae\u30b0\u30b2\u30b4"	// KMOQS
			+ "\u30b6\u30b8\u30ba\u30bc\u30be"	// UWY[]
			+ "\u30c0\u30c2\u30c5\u30c7\u30c9"	// _adfh
			+ "\u30d0\u30d3\u30d6\u30d9\u30dc"	// orux{
			+ "\u30f4";							// 

	/** SpJ^Jie[u */
	protected static final String EM_SIZE_HANDAKUON_KATAKANA_TABLE =
			"\u30d1\u30d4\u30d7\u30da\u30dd";	// psvy|

	/** pXy[X */
	protected static final char NORMAL_WIDTH_SPACE = '\u0020';
	/** SpXy[X */
	protected static final char EM_SIZE_SPACE = '\u3000';
	/** p_ */
	protected static final char NORMAL_WIDTH_DAKUTEN = '\uff9e';
	/** p_ */
	protected static final char NORMAL_WIDTH_HANDAKUTEN = '\uff9f';
	/** Sp_ */
	protected static final char EM_SIZE_DAKUTEN = '\u309b';
	/** Sp_ */
	protected static final char EM_SIZE_HANDAKUTEN = '\u309c';

	/**
	 * SpJ^Jiɕϊ܂B
	 *
	 * @param	str	ϊΏە
	 * @return	SpJ^Jiɕϊꂽ
	 */
	public static String toKatakana(String str) {

		// ϊΏەnull̏ꍇnullԂ
		if (str == null) return null;

		StringBuffer ret = new StringBuffer();
		for (int i=0; i<str.length(); i++) {
			char code = str.charAt(i);
			if (isHiragana(code)) {
				// ̂ƂSpJ^Jiɕϊ
				ret.append((char)(code + 0x60));
			} else {
				// ȊO͂̂܂
				ret.append(code);
			}
		}

		return ret.toString();
	}

	/**
	 * SpJ^Ji𕽉ɕϊ܂B
	 * Á̕AɑΉ镶Ȃ̂ŕϊ܂B
	 * <ul>
	 *   <li> ('\u30f4')</li>
	 *   <li> ('\u30f5')</li>
	 *   <li> ('\u30f6')</li>
	 * </ul>
	 *
	 * @param	str	ϊΏە
	 * @return	SpJ^Jiɕϊꂽ
	 */
	public static String toHiragana(String str) {

		// ϊΏەnull̏ꍇnullԂ
		if (str == null) return null;

		StringBuffer ret = new StringBuffer();
		for (int i=0; i<str.length(); i++) {
			char code = str.charAt(i);
			if (isKatakana(code)
					&& (!(code == '\u30f4'
						|| code == '\u30f5'
						|| code == '\u30f6'))) {	// '','',''͏
				// SpJ^JîƂɕϊ
				ret.append((char)(code - 0x60));
			} else {
				// SpJ^JiȊO͂̂܂
				ret.append(code);
			}
		}

		return ret.toString();
	}

	/**
	 * ppLSpɕϊ܂B
	 *
	 * @param	str	ϊΏە
	 * @return	ppLSpɕϊꂽ
	 */
	public static String toEmSizeANS(String str) {

		// ϊΏەnull̏ꍇnullԂ
		if (str == null) return null;

		StringBuffer ret = new StringBuffer();
		for (int i=0; i<str.length(); i++) {
			char code = str.charAt(i);
			if (isNormalWidthANS(code)) {
				// ppL̂ƂSpɕϊ
				ret.append((char)(code + 0xfee0));
			} else {
				// ppLȊO͂̂܂
				ret.append(code);
			}
		}

		return ret.toString();
	}

	/**
	 * SppL𔼊pɕϊ܂B
	 *
	 * @param	str	ϊΏە
	 * @return	SppLpɕϊꂽ
	 */
	public static String toNormalWidthANS(String str) {

		// ϊΏەnull̏ꍇnullԂ
		if (str == null) return null;

		StringBuffer ret = new StringBuffer();
		for (int i=0; i<str.length(); i++) {
			char code = str.charAt(i);
			if (isEmSizeANS(code)) {
				// SppL̂Ƃpɕϊ
				ret.append((char)(code - 0xfee0));
			} else {
				// SppLȊO͂̂܂
				ret.append(code);
			}
		}

		return ret.toString();
	}

	/**
	 * pXy[XSpɕϊ܂B
	 *
	 * @param	str	ϊΏە
	 * @return	pXy[XSpɕϊꂽ
	 */
	public static String toEmSizeSpace(String str) {

		// ϊΏەnull̏ꍇnullԂ
		if (str == null) return null;

		StringBuffer ret = new StringBuffer();
		for (int i=0; i<str.length(); i++) {
			char code = str.charAt(i);
			if (isNormalWidthSpace(code)) {
				// pXy[X̂ƂSpɕϊ
				ret.append(EM_SIZE_SPACE);
			} else {
				// pXy[XȊO͂̂܂
				ret.append(code);
			}
		}

		return ret.toString();
	}

	/**
	 * SpXy[X𔼊pɕϊ܂B
	 *
	 * @param	str	ϊΏە
	 * @return	SpXy[Xpɕϊꂽ
	 */
	public static String toNormalWidthSpace(String str) {

		// ϊΏەnull̏ꍇnullԂ
		if (str == null) return null;

		StringBuffer ret = new StringBuffer();
		for (int i=0; i<str.length(); i++) {
			char code = str.charAt(i);
			if (isEmSizeSpace(code)) {
				// SpXy[X̂Ƃpɕϊ
				ret.append(NORMAL_WIDTH_SPACE);
			} else {
				// SpXy[XȊO͂̂܂
				ret.append(code);
			}
		}

		return ret.toString();
	}

	/**
	 * pJ^JiSpɕϊ܂B
	 *
	 * @param	str	ϊΏە
	 * @return	pJ^JiSpɕϊꂽ
	 */
	public static String toEmSizeKatakana(String str) {

		// ϊΏەnull̏ꍇnullԂ
		if (str == null) return null;

		StringBuffer ret = new StringBuffer();
		for (int i=0; i<str.length(); i++) {
			char code = str.charAt(i);
			// SpJ^Jiɕϊ\Ȃϊ
			if (isConvertibleEmSizeKatakana(code)) {

				// p_ȂSpɋɗ͕ϊ
				if (code == NORMAL_WIDTH_DAKUTEN) {
					if (i > 0) {
						char before = str.charAt(i-1);
						int beforeIndex = NORMAL_WIDTH_DAKUON_KATAKANA_TABLE.indexOf(before);
						if (beforeIndex >= 0) {
							// Spɕϊoꍇ͕ϊ(:  -> K)
							ret.deleteCharAt(ret.length() - 1).append(EM_SIZE_DAKUON_KATAKANA_TABLE.charAt(beforeIndex));
						} else {
							// SpɕϊoȂꍇ͂̂܂ܑSp_ɕϊ(:  -> AJ)
							ret.append(EM_SIZE_DAKUTEN);
						}
					} else {
						// (@Iɂ͂肦Ȃ)1ڂp_̏ꍇ͂̂܂ܑSp_ɕϊ
						ret.append(EM_SIZE_DAKUTEN);
					}
				}
				// p_ȂSpɋɗ͕ϊ
				else if (code == NORMAL_WIDTH_HANDAKUTEN) {
					if (i > 0) {
						char before = str.charAt(i-1);
						int beforeIndex = NORMAL_WIDTH_HANDAKUON_KATAKANA_TABLE.indexOf(before);
						if (beforeIndex >= 0) {
							// Spɕϊoꍇ͕ϊ(:  -> p)
							ret.deleteCharAt(ret.length() - 1).append(EM_SIZE_HANDAKUON_KATAKANA_TABLE.charAt(beforeIndex));
						} else {
							// SpɕϊoȂꍇ͂̂܂ܑSp_ɕϊ(:  -> AK)
							ret.append(EM_SIZE_HANDAKUTEN);
						}
					} else {
						// (@Iɂ͂肦Ȃ)1ڂp_̏ꍇ͂̂܂ܑSp_ɕϊ
						ret.append(EM_SIZE_HANDAKUTEN);
					}
				}
				// ȊO͑SpJ^Jiɕϊ
				else {
					int index = NORMAL_WIDTH_KATAKANA_TABLE.indexOf(code);
					ret.append(EM_SIZE_KATAKANA_TABLE.charAt(index));
				}

			// ϊs\Ȃ炻̂܂
			} else {
				ret.append(code);
			}
		}

		return ret.toString();
	}

	/**
	 * SpJ^Ji𔼊pɕϊ܂B
	 *
	 * @param	str	ϊΏە
	 * @return	SpJ^Jipɕϊꂽ
	 */
	public static String toNormalWidthKatakana(String str) {

		// ϊΏەnull̏ꍇnullԂ
		if (str == null) return null;

		StringBuffer ret = new StringBuffer();
		for (int i=0; i<str.length(); i++) {
			char code = str.charAt(i);
			// pJ^Jiɕϊ\Ȃϊ
			if (isConvertibleNormalWidthKatakana(code)) {
				if (EM_SIZE_KATAKANA_TABLE.indexOf(code) >= 0) {
					int index = EM_SIZE_KATAKANA_TABLE.indexOf(code);
					ret.append(NORMAL_WIDTH_KATAKANA_TABLE.charAt(index));
				}
				// ͔pJ^Ji{p_ɕϊ(: K -> )
				else if (EM_SIZE_DAKUON_KATAKANA_TABLE.indexOf(code) >= 0) {
					int index = EM_SIZE_DAKUON_KATAKANA_TABLE.indexOf(code);
					ret.append(NORMAL_WIDTH_DAKUON_KATAKANA_TABLE.charAt(index)).append(NORMAL_WIDTH_DAKUTEN);
				}
				// ͔pJ^Ji{p_ɕϊ(: p -> )
				else if (EM_SIZE_HANDAKUON_KATAKANA_TABLE.indexOf(code) >= 0) {
					int index = EM_SIZE_HANDAKUON_KATAKANA_TABLE.indexOf(code);
					ret.append(NORMAL_WIDTH_HANDAKUON_KATAKANA_TABLE.charAt(index)).append(NORMAL_WIDTH_HANDAKUTEN);
				} 
			// ϊs\Ȃ炻̂܂
			} else {
				ret.append(code);
			}
		}

		return ret.toString();
	}

	/**
	 * ۂ𔻒肵܂B
	 * ɂUnicode}bv0x3041`0x3093͈̔͂ɑĂ邩ۂ𔻒肵܂B
	 *
	 * @param	c	Ώە
	 * @return	Ȃ^
	 */
	protected static boolean isHiragana(char c) {
		if (('\u3041' <= c) && (c <= '\u3093')) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 * SpJ^Jiۂ𔻒肵܂B
	 * ɂUnicode}bv0x30a1`0x30f6͈̔͂ɑĂ邩ۂ𔻒肵܂B
	 *
	 * @param	c	Ώە
	 * @return	SpJ^JiȂ^
	 */
	protected static boolean isKatakana(char c) {
		if (('\u30a1' <= c) && (c <= '\u30f6')) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 * pJ^Jiۂ𔻒肵܂B
	 * ɂUnicode}bv0xff61`0xff9f͈̔͂ɑĂ邩ۂ𔻒肵܂B
	 *
	 * @param	c	Ώە
	 * @return	pJ^JiȂ^
	 */
	protected static boolean isNormalWidthKatakana(char c) {
		if (('\uff61' <= c) && (c <= '\uff9f')) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 * ppLۂ𔻒肵܂B
	 * ɂUnicode}bv0x21`0x7e͈̔͂ɑĂ邩ۂ𔻒肵܂B
	 *
	 * @param	c	Ώە
	 * @return	ppLȂ^
	 */
	protected static boolean isNormalWidthANS(char c) {
		if (('\u0021' <= c) && (c <= '\u007e')) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 * SppLۂ𔻒肵܂B
	 * ɂUnicode}bv0xff01`0xff4e͈̔͂ɑĂ邩ۂ𔻒肵܂B
	 *
	 * @param	c	Ώە
	 * @return	SppLȂ^
	 */
	protected static boolean isEmSizeANS(char c) {
		if (('\uff01' <= c) && (c <= '\uff4e')) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 * pXy[Xۂ𔻒肵܂B
	 *
	 * @param	c	Ώە
	 * @return	pXy[XȂ^
	 */
	protected static boolean isNormalWidthSpace(char c) {
		if (NORMAL_WIDTH_SPACE == c) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 * SpXy[Xۂ𔻒肵܂B
	 *
	 * @param	c	Ώە
	 * @return	SpXy[XȂ^
	 */
	protected static boolean isEmSizeSpace(char c) {
		if (EM_SIZE_SPACE == c) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 * pJ^Jiɕϊ\ȑSpJ^Jiۂ𔻒肵܂B
	 * ɂ͑Spe[u(_A_e[u܂)ɂ邩ۂ𔻒肵܂B
	 *
	 * @param	c	Ώە
	 * @return	pJ^Jiɕϊ\ȑSpJ^JiȂ^
	 */
	protected static boolean isConvertibleNormalWidthKatakana(char c) {
		if ((EM_SIZE_KATAKANA_TABLE.indexOf(c) >= 0)
				|| (EM_SIZE_DAKUON_KATAKANA_TABLE.indexOf(c) >= 0)
				|| (EM_SIZE_HANDAKUON_KATAKANA_TABLE.indexOf(c) >= 0)) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 * SpJ^Jiɕϊ\ȔpJ^Jiۂ𔻒肵܂B
	 * ɂ͔pJ^Jie[uɂ邩𔻒肵܂B
	 *
	 * @param	c	Ώە
	 * @return	SpJ^Jiɕϊ\ȔpJ^JiȂ^
	 */
	protected static boolean isConvertibleEmSizeKatakana(char c) {
		if (NORMAL_WIDTH_KATAKANA_TABLE.indexOf(c) >= 0) {
			return true;
		} else {
			return false;
		}
	}
}
